package de.groygroy.wahl2009;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import org.zkoss.zk.ui.util.GenericForwardComposer;


/**
 * Eine einfache Wrapperklasse, zustaändig für das Parsen, stellt die Ergebnisse als Singleton zur
 * Verfügung.
 *
 * @author  cz
 */
public final class Wahlergebniss2009 extends GenericForwardComposer {

    private static Logger log = Logger.getLogger( Wahlergebniss2009.class.getName() );
    private static final List< Stadtteil > stadtteile;
    private static final Wahlergebniss2009 instance;

    static {

        List< Stadtteil > tmp = new ArrayList< Stadtteil >();

        try {

            BufferedReader reader = new BufferedReader( new InputStreamReader(
                        Wahlergebniss2009.class.getResourceAsStream( "wahlHH2009.csv" ) ) );
            String line;

            while ( ( line = reader.readLine() ) != null ) {

                if ( line.startsWith( "\"#" ) ) {
                    continue;
                }

                String[] csvLine = line.split( ";" );
                tmp.add( new Stadtteil( csvLine ) );

            }

        } catch ( Exception exp ) {
            log.log( Level.SEVERE, "CSV Laden sclug fehl", exp );
            tmp = new ArrayList< Stadtteil >();
        } finally {
            stadtteile = tmp;
        }

        instance = new Wahlergebniss2009();

    }

    public static Wahlergebniss2009 getInstance() {
        return instance;
    }

    public List< Stadtteil > getStadtteile() {
        return stadtteile;
    }
}
